<template>
  <div class="sourcepanel">
    <!-- <base-dialog :show="!!error" title="An error occurred!" @close="handleError">
      <p>{{ error }}</p>
    </base-dialog> -->
    <div class="inputURLcontainer">
      <div class="inputURL">
        <input
          class="inputText"
          type="text"
          placeholder="Input URL"
          name="inputText"
          id="inputText"
          v-model="inputSearch"
          @keyup.enter="onChangeInputSearch"
          autocomplete="off"
        />
        <a
          class="send-button"
          @click.prevent="onChangeInputSearch"
          title="Get data"
        >
          <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 21 23" fill="none">
<path d="M19.3335 2.32422L6.8335 13.2945V19.6939L9.8335 15.8086" stroke="#404040" stroke-width="2" stroke-miterlimit="10"/>
<path d="M2.66699 9.63776L19.3336 2.32422L16.0003 20.6081L2.66699 9.63776Z" stroke="#404040" stroke-width="2" stroke-miterlimit="10" stroke-linecap="square"/>
</svg>
        </a>
      </div>
    </div>

    <hr />

    <div class="source-panel_tabs">
      <h4>GENERATED COMPONENT</h4>
      <div class="tab-content">
        <div id="menu1" class="tab-pane fade in active" style="padding-bottom:15px">
          <div v-if="isLoading">
            <base-spinner></base-spinner>
          </div>
          <ul v-else-if="GETTER_DATA_HAS_PRODUCT">
            <BloggerList
              v-for="(data_search, index) in GETTER_DATA_SEARCH"
              :key="index"
              :list-image="data_search"
            />
          </ul>
          <div v-else class="nodata">
            <h3>NO DATA</h3>
            <span>Please enter URL's post to get your data</span>
          </div>
          <br />
        </div>
      </div>
    </div>
    <div>
      <!-- <h4>footer source panel</h4> -->
    </div>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import { ModalBus } from "../eventBus";
import BloggerList from "@/components/BloggerList";
import Alert from "@/components/Alert";
export default {
  data() {
    return {
      inputSearch: "",
      isLoading: false
    };
  },
  components: {
    BloggerList
  },
  computed: {
    ...mapGetters([
      "GETTER_DATA_SEARCH",
      "GETTER_DATA_TOP_PICK",
      "GETTER_DATA_HAS_PRODUCT"
    ])
  },
  methods: {
    async onChangeInputSearch() {
      let input = this.inputSearch;
       let arrInput = input.split("?");
      let params = arrInput[0].split("/").pop();
      const props = {
        type: "",
        text: ""
      };

      this.isLoading = true;
      if (this.GETTER_DATA_TOP_PICK.filter(e => e.id === params).length === 1) {
        props.type = "warning";
        props.text = "This blogger is existed. Please choose another blogger.";
        ModalBus.$emit("open", {
          component: Alert,
          title: "Warning",
          mode: "fiftyPercent",
          props
        });
        this.inputSearch = "";
      }
      if (this.GETTER_DATA_TOP_PICK.filter(e => !e.id).length > 0) {
        // LTK VERSION 1
        // await this.$store.dispatch("LTKS_REQUEST", { params, index: -1 });
        // LTK VERSION 2
        await this.$store.dispatch("RS_REQUEST", { params, index: -1 });
        this.inputSearch = "";
      } else {
        props.type = "info";
        props.text = "Please, add a new row to update the list.";
        ModalBus.$emit("open", {
          component: Alert,
          title: "Information",
          mode: "fiftyPercent",
          props
        });
      }
      this.isLoading = false;
    }
  }
};
</script>

<style scoped>
.send-button:hover {
  text-decoration: none;
}

ul.nav li {
  font-size: 14px;
}

.sourcepanel {
  position: fixed;
  overflow: auto;
  height: 100%;
  /* box-shadow: 0px 4px 4px rgba(0, 0, 0, 0.25); */
}

.nodata {
  text-align: center;
  border: 0.5px dashed #888;
  padding: 20px 0 40px 0;
  margin: 20px auto;
  color: #888;
}
</style>
